class Cell
{
  int dday;
  int col;
  int row;
  color clr, cclr;
  float h;  
  ArrayList movements = new ArrayList();
 
  public Cell(int dday, int col, int row, float h, color clr)
  {
    this.dday = dday;
    this.col = col;
    this.row = row;
    this.h = h;
    this.clr = clr;
    this.cclr = color(red(clr), green(clr), blue(clr));
  }

  public void update()
  {
    for (int i = movements.size() - 1; i >= 0; i--)
    {
      MovementTimer mt = (MovementTimer) movements.get(i);

    if (col == 0 && row == 0)
     {
       //println("updating...");
       
     }
  
      if (mt.update(millis()))
      {
        movements.remove(mt);
      }
    }  
  }

  String toString()
  {
    return "day " + dday + " col/row = " + col + "/" + row;
  }
  
  void draw(float sx, float sy, float sw, float sh)
  {
    sx += row * sw;
    sy += col * sh;

   fill(clr);
   stroke(255);
    beginShape(QUADS);


    // Bottom face
    vertex(sx, sy, 0); 
    vertex(sx + sw, sy, 0); 
    vertex(sx + sw, sy + sh, 0); 
    vertex(sx, sy + sh, 0); 

  
    // Front face
    vertex(sx, sy, 0); 
    vertex(sx + sw, sy, 0); 
    vertex(sx + sw, sy, h); 
    vertex(sx, sy, h); 

    // Right face
    vertex(sx + sw, sy, 0); 
    vertex(sx + sw, sy + sh, 0); 
    vertex(sx + sw, sy + sh, h); 
    vertex(sx + sw, sy, h); 

    // Back face
    vertex(sx + sw, sy + sh, 0); 
    vertex(sx, sy + sh, 0); 
    vertex(sx, sy + sh, h); 
    vertex(sx + sw, sy + sh, h); 

    // Left face
    vertex(sx, sy + sh, 0); 
    vertex(sx, sy, 0); 
    vertex(sx, sy, h); 
    vertex(sx, sy + sh, h);

  // Top face
    vertex(sx, sy, h); 
    vertex(sx + sw, sy, h); 
    vertex(sx + sw, sy + sh, h); 
    vertex(sx, sy + sh, h); 

    endShape(); 

  pushMatrix();
  {
    float tx = sx + (2);
    float ty = sy + (sh - 2);
    if (h > 0)
    {
      fill(255);
      translate(tx, ty, h+1);
    }
    else 
    {
      fill(255,0,0);
      
      translate(tx, ty, h-1);
       rotateX(PI);   
       //translate(0f, sy, 0f);
    }
    text((int) abs(h), 0,0);
  }
  popMatrix();
  
  }
}

