class MovementTimer
{
  Cell cell;
  long start;
  long end;
  long previous;
  float hmov, rmov, gmov, bmov;
  
  public MovementTimer(Cell cell, long start, long end, float hmov, float rmov, float gmov, float bmov)
  {
   this.start = start;
   this.previous = start;
   this.end = end; 
   
   this.hmov = hmov;
   this.rmov = rmov;
   this.gmov = gmov;
   this.bmov = bmov;
   
   this.cell = cell;
   cell.movements.add(this);
  }
  
  //return true if it should be detached
  public boolean update(long current)
  {
      boolean readyToRemove = false;
      if (current <= start)
      {
  //      println("not ready...");
        return false; //do nothing, we are not ready to change
      }
      
      if (current >= end)
      {
    //    println("done...");
        //move to end, then detach myself from the player
        current = end;
        readyToRemove = true;  
      }
      
      float lastTimePercentage = (float)(previous - start) / (float)(end - start);
      float thisTimePercentage = (float)(current - start) / (float)(end - start);
      float percDiff = thisTimePercentage - lastTimePercentage;
 
//  println("changing...  " + (hmov * percDiff));
       
      cell.h += (hmov * percDiff);
      float r= red(cell.clr);
      float g= green(cell.clr);
      float b= blue(cell.clr);
      cell.clr = color(r + rmov * percDiff, g + gmov * percDiff, b + bmov * percDiff);   
      previous = current;
      return readyToRemove;   
  }
  
  
}
